# -*- coding: utf-8 -*-
from scrapy.spider import BaseSpider
from scrapy.selector import HtmlXPathSelector
from ucalendar.items import UcalendarItem

class UcalendarSpider(BaseSpider):
    domain_name = "uwaterloo.ca"
    start_urls = [
        "http://www.ucalendar.uwaterloo.ca/0910/COURSE/course-SE.html"
    ]

    def parse(self, response):
	hxs = HtmlXPathSelector(response)
	tables = hxs.select('//table[@width="80%"]')
	items = []
        for table in tables:
	    item = UcalendarItem()
	    item['desc'] = table.select('tr[3]/td/text()').extract()
	    item['name'] = table.select('tr[2]/td/b/text()').extract()
	    item['course'] = table.select('tr[1]/td/b/text()').re('([A-Z]{2,5} \d{3})')
	    item['offered'] = table.select('tr[3]/td').re('.*\[.*Offered: (F|W|S)+,* *(F|W|S)*,* *(F|W|S)*\]')
	    item['prereq'] = table.select('tr[5]/td/i/text()').re('([A-Z]{2,5} \d{3})')
            items.append(item)
	return items

SPIDER = UcalendarSpider()
